/*
 * Craciun Alexandru
 * 334CB
 * Ultimate Tic Tac Toe
 */
 
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "usart.h"
#include <avr/interrupt.h>
#include <avr/io.h>
#include <util/delay.h>

/* Initializare buzzer */
void init_buzzer()
{
	/* Setam PB0 ca iesire */
	DDRB |= (1 << PB0);
}

/* Activeaza buzzer pentru un timp anume */
void buzz(int time)
{
	if(time <= 0)
		return;
	PORTB |= (1 << PB0);
	_delay_ms(time);
	PORTB  &= ~(1 << PB0);
}

/* Aprindere ledul in functie de inputul primit de la bluetooth */
void luminate_led(int position)
{
	/* Activarea pe coloana - pinii negativi */
	if(position % 9 == 0)
	{
		DDRA |= (1 << PA0);
		PORTA |= (1 << PA0);
	}
	if(position % 9 == 1)
	{
		DDRA |= (1 << PA2);
		PORTA |= (1 << PA2);
	}
	if(position % 9 == 2)
	{
		DDRA |= (1 << PA4);
		PORTA |= (1 << PA4);
	}
	if(position % 9 == 3)
	{
		DDRA |= (1 << PA6);
		PORTA |= (1 << PA6);
	}
	if(position % 9 == 4)
	{
		DDRA |= (1 << PC0);
		PORTA |= (1 << PC0);
	}
	if(position % 9 == 5)
	{
		DDRA |= (1 << PC2);
		PORTA |= (1 << PC2);
	}
	if(position % 9 == 6)
	{
		DDRA |= (1 << PC4);
		PORTA |= (1 << PC4);
	}
	if(position % 9 == 7)
	{
		DDRA |= (1 << PC6);
		PORTA |= (1 << PC6);
	}
	if(position % 9 == 8)
	{
		DDRB |= (1 << PB1);
		PORTB |= (1 << PB1);
	}
	
	/* Activarea pe linii - pinii pozitivi */
	if(position / 9 == 0)
	{
		DDRC |= (1 << PA1);
		PORTC |= (1 << PA1);
	}
	if(position / 9 == 1)
	{
		DDRC |= (1 << PA3);
		PORTC |= (1 << PA3);
	}
	if(position / 9 == 2)
	{
		DDRC |= (1 << PA5);
		PORTC |= (1 << PA5);
	}
	if(position / 9 == 3)
	{
		DDRC |= (1 << PA7);
		PORTC |= (1 << PA7);
	}
	if(position / 9 == 4)
	{
		DDRC |= (1 << PC1);
		PORTC |= (1 << PC1);
	}
	if(position / 9 == 5)
	{
		DDRC |= (1 << PC3);
		PORTC |= (1 << PC3);
	}
	if(position / 9 == 6)
	{
		DDRC |= (1 << PC5);
		PORTC |= (1 << PC5);
	}
	if(position / 9 == 7)
	{
		DDRC |= (1 << PC7);
		PORTC |= (1 << PC7);
	}
	if(position / 9 == 8)
	{
		DDRB |= (1 << PB2);
		PORTB |= (1 << PB2);
	}
}

/* Stingerea tuturor led-urilor */
void game_finished()
{
	DDRA |= (1 << PA0);
	PORTA &= ~(1 << PA0);
	DDRA |= (1 << PA1);
	PORTA &= ~(1 << PA1);
	DDRA |= (1 << PA2);
	PORTA &= ~(1 << PA2);
	DDRA |= (1 << PA3);
	PORTA &= ~(1 << PA3);
	DDRA |= (1 << PA4);
	PORTA &= ~(1 << PA4);
	DDRA |= (1 << PA5);
	PORTA &= ~(1 << PA5);
	DDRA |= (1 << PA6);
	PORTA &= ~(1 << PA6);
	DDRA |= (1 << PA7);
	PORTA &= ~(1 << PA7);

	DDRB |= (1 << PB1);
	PORTB &= ~(1 << PB1);
	DDRB |= (1 << PB2);
	PORTB &= ~(1 << PB2);
	
	DDRC |= (1 << PC0);
	PORTC &= ~(1 << PC0);
	DDRC |= (1 << PC1);
	PORTC &= ~(1 << PC1);
	DDRC |= (1 << PC2);
	PORTC &= ~(1 << PC2);
	DDRC |= (1 << PC3);
	PORTC &= ~(1 << PC3);
	DDRC |= (1 << PC4);
	PORTC &= ~(1 << PC4);
	DDRC |= (1 << PC5);
	PORTC &= ~(1 << PC5);
	DDRC |= (1 << PC6);
	PORTC &= ~(1 << PC6);
	DDRC |= (1 << PC7);
	PORTC &= ~(1 << PC7);
}


/* Primirea datelor prin bluetooth */
void bluetooth()
{	
	char c;
	int index = 0;
	
	/* Nume jucator */
	char name[256];
	int name_completed = 0;
	
	/* Pozitia ledului */
	int led_position[2];
	led_position[0] = 0;
	led_position[1] = 0;
	
	while(1)
	{
		/* Asteptam caracter prin USART */
		c = USART0_receive();
		
		/* Completare nume jucator */
		if(name_completed == 0 && c != '/')
		{
			name[index++] = c;
		}
		if(name_completed == 0 && c == '/')
		{
			index = 0;
			name_completed = 1;
			buzz(50);
		}
		
		/* Primire pozitie de led*/
		if(name_completed == 1 && c != '/')
		{
			led_position[index++] = c - '0'; 
		}
		if(name_completed == 1 && c == '/')
		{
			int position = led_position[1] * 10 + led_position[0];
			luminate_led(position);
			buzz(5);
		}
		
		if(name_completed == 1 && c == 'f')
		{
			game_finished();
		}
	}
}


int main(void) {
	
	/* Initializari */
	USART0_init();
	init_buzzer();
	
	/* Inchiderea pinilor - verificare de siguranta */
	game_finished();

	/* Incepem conexiunea */
	bluetooth();
	
	return 0;
}
